Index: fact/tools/pyscripts/doc/_build/html/_sources/getting_started.txt
===================================================================
--- fact/tools/pyscripts/doc/_build/html/_sources/getting_started.txt	(revision 13316)
+++ fact/tools/pyscripts/doc/_build/html/_sources/getting_started.txt	(revision 13324)
@@ -39,5 +39,4 @@
     * pyscript/tools
     * pyscripts/ecamples
-    * py
 
 the absolute path depends on where you have checked (or will check) out the pyscripts repository
@@ -47,26 +46,38 @@
 svn co https://fact.isdc.unige.ch/svn/fact/tools/pyscripts/
 
-4. Create pyfits library
+4. Create pyfits_h.so library
 ========================
-FACT data are stored in (gzipped) fits files, but the data files are too large to be read by the default tool: 
+FACT data are stored in (gzipped) fits files, but the data files are too large to be read by the existing tools: 
 
-`pyfits <http://www.stsci.edu/institute/software_hardware/pyfits>`.
+`pyfits <http://www.stsci.edu/institute/software_hardware/pyfits>` which uses `cfitsio <http://heasarc.gsfc.nasa.gov/fitsio/>`_.
 
-To mitigate this problem a C++ class defined in `fits.h` is used. A simple possibility to create an interface of this C++ class and python is to use the 
+To mitigate this problem a C++ class defined in fits.h [#f1]_ is used. A simple possibility to create an interface of this C++ class is to use ROOT and later to import it using the
+`pyroot <http://root.cern.ch/drupal/category/package-context/pyroot>`_ module.
 
-`pyroot http://root.cern.ch/drupal/category/package-context/pyroot>` module.
+got to the directory: pyscripts/pyfact
 
 simple::
 
-  [pceth118] /home/luster/py > root
-  ROOT 5.28/00h (branches/v5-28-00-patches@42209, Feb 13 2012, 23:52:00 on linux)
+  [lusterma@isdc-cn02 pyfact]$ root
+  ROOT 5.28/00 (trunk@37585, Dec 14 2010, 15:20:27 on linuxx8664gcc)
   CINT/ROOT C/C++ Interpreter version 5.18.00, July 2, 2010
   Type ? for help. Commands must be C++ statements.
   Enclose multiple statements between { }.
+
   root [0] .L fits.h++
-  Info in <TUnixSystem::ACLiC>: creating shared library /home/luster/py/./fits_h.so
+  Info in <TUnixSystem::ACLiC>: creating shared library /home_nfs/isdc/lusterma/pyscripts/pyfact/./fits_h.so
   root [1]
 
+This might not work for whatenver reason then it should be done like this::
 
+  $rootcint -f my_dict.C -c fits.h izstream.h
+  $g++ -fPIC -c -I$ROOTSYS/include my_dict.C -o my_dict.o
+  $g++ -o fits_h.so -shared my_dict.o
+
+Now you can check if the reading rawdata is working:
+
+$ pyfact.py
+
+this should print some data from a few events
 
 5. Run examples
@@ -93,2 +104,4 @@
 
 
+.. rubric:: Footnotes
+.. [#f1] fits.h (here named pyfits.h) is part of MARS and was written by T.Bretz, it was added to this repository for convienience
Index: fact/tools/pyscripts/doc/_build/html/classes.html
===================================================================
--- fact/tools/pyscripts/doc/_build/html/classes.html	(revision 13316)
+++ fact/tools/pyscripts/doc/_build/html/classes.html	(revision 13324)
@@ -25,5 +25,5 @@
     <link rel="top" title="pyfact v0.1 documentation" href="index.html" />
     <link rel="next" title="Examples" href="examples.html" />
-    <link rel="prev" title="Introduction" href="introduction.html" /> 
+    <link rel="prev" title="Getting Started" href="getting_started.html" /> 
   </head>
   <body>
@@ -38,5 +38,5 @@
              accesskey="N">next</a> |</li>
         <li class="right" >
-          <a href="introduction.html" title="Introduction"
+          <a href="getting_started.html" title="Getting Started"
              accesskey="P">previous</a> |</li>
         <li><a href="index.html">pyfact v0.1 documentation</a> &raquo;</li> 
@@ -113,6 +113,6 @@
 
   <h4>Previous topic</h4>
-  <p class="topless"><a href="introduction.html"
-                        title="previous chapter">Introduction</a></p>
+  <p class="topless"><a href="getting_started.html"
+                        title="previous chapter">Getting Started</a></p>
   <h4>Next topic</h4>
   <p class="topless"><a href="examples.html"
@@ -150,5 +150,5 @@
              >next</a> |</li>
         <li class="right" >
-          <a href="introduction.html" title="Introduction"
+          <a href="getting_started.html" title="Getting Started"
              >previous</a> |</li>
         <li><a href="index.html">pyfact v0.1 documentation</a> &raquo;</li> 
Index: fact/tools/pyscripts/doc/_build/html/getting_started.html
===================================================================
--- fact/tools/pyscripts/doc/_build/html/getting_started.html	(revision 13316)
+++ fact/tools/pyscripts/doc/_build/html/getting_started.html	(revision 13324)
@@ -92,5 +92,4 @@
 <li>pyscript/tools</li>
 <li>pyscripts/ecamples</li>
-<li>py</li>
 </ul>
 </dd>
@@ -104,20 +103,30 @@
 <p>svn co <a class="reference external" href="https://fact.isdc.unige.ch/svn/fact/tools/pyscripts/">https://fact.isdc.unige.ch/svn/fact/tools/pyscripts/</a></p>
 </div>
-<div class="section" id="create-pyfits-library">
-<h2>4. Create pyfits library<a class="headerlink" href="#create-pyfits-library" title="Permalink to this headline">¶</a></h2>
-<p>FACT data are stored in (gzipped) fits files, but the data files are too large to be read by the default tool:</p>
-<p><cite>pyfits &lt;http://www.stsci.edu/institute/software_hardware/pyfits&gt;</cite>.</p>
-<p>To mitigate this problem a C++ class defined in <cite>fits.h</cite> is used. A simple possibility to create an interface of this C++ class and python is to use the</p>
-<p><cite>pyroot http://root.cern.ch/drupal/category/package-context/pyroot&gt;</cite> module.</p>
+<div class="section" id="create-pyfits-h-so-library">
+<h2>4. Create pyfits_h.so library<a class="headerlink" href="#create-pyfits-h-so-library" title="Permalink to this headline">¶</a></h2>
+<p>FACT data are stored in (gzipped) fits files, but the data files are too large to be read by the existing tools:</p>
+<p><cite>pyfits &lt;http://www.stsci.edu/institute/software_hardware/pyfits&gt;</cite> which uses <a class="reference external" href="http://heasarc.gsfc.nasa.gov/fitsio/">cfitsio</a>.</p>
+<p>To mitigate this problem a C++ class defined in fits.h <a class="footnote-reference" href="#f1" id="id1">[1]</a> is used. A simple possibility to create an interface of this C++ class is to use ROOT and later to import it using the
+<a class="reference external" href="http://root.cern.ch/drupal/category/package-context/pyroot">pyroot</a> module.</p>
+<p>got to the directory: pyscripts/pyfact</p>
 <p>simple:</p>
-<div class="highlight-python"><pre>[pceth118] /home/luster/py &gt; root
-ROOT 5.28/00h (branches/v5-28-00-patches@42209, Feb 13 2012, 23:52:00 on linux)
+<div class="highlight-python"><pre>[lusterma@isdc-cn02 pyfact]$ root
+ROOT 5.28/00 (trunk@37585, Dec 14 2010, 15:20:27 on linuxx8664gcc)
 CINT/ROOT C/C++ Interpreter version 5.18.00, July 2, 2010
 Type ? for help. Commands must be C++ statements.
 Enclose multiple statements between { }.
+
 root [0] .L fits.h++
-Info in &lt;TUnixSystem::ACLiC&gt;: creating shared library /home/luster/py/./fits_h.so
+Info in &lt;TUnixSystem::ACLiC&gt;: creating shared library /home_nfs/isdc/lusterma/pyscripts/pyfact/./fits_h.so
 root [1]</pre>
 </div>
+<p>This might not work for whatenver reason then it should be done like this:</p>
+<div class="highlight-python"><pre>$rootcint -f my_dict.C -c fits.h izstream.h
+$g++ -fPIC -c -I$ROOTSYS/include my_dict.C -o my_dict.o
+$g++ -o fits_h.so -shared my_dict.o</pre>
+</div>
+<p>Now you can check if the reading rawdata is working:</p>
+<p>$ pyfact.py</p>
+<p>this should print some data from a few events</p>
 </div>
 <div class="section" id="run-examples">
@@ -133,5 +142,5 @@
 <dl class="class">
 <dt id="pyfact.RawData">
-<em class="property">class </em><tt class="descclassname">pyfact.</tt><tt class="descname">RawData</tt><big>(</big><em>data_file_name</em>, <em>calib_file_name</em>, <em>user_action_calib=&lt;function &lt;lambda&gt; at 0xa818844&gt;</em>, <em>baseline_file_name=''</em>, <em>return_dict=None</em><big>)</big><a class="headerlink" href="#pyfact.RawData" title="Permalink to this definition">¶</a></dt>
+<em class="property">class </em><tt class="descclassname">pyfact.</tt><tt class="descname">RawData</tt><big>(</big><em>data_file_name</em>, <em>calib_file_name</em>, <em>user_action_calib=&lt;function &lt;lambda&gt; at 0xab028b4&gt;</em>, <em>baseline_file_name=''</em>, <em>return_dict=None</em><big>)</big><a class="headerlink" href="#pyfact.RawData" title="Permalink to this definition">¶</a></dt>
 <dd><p>raw data access and calibration</p>
 <ul class="simple">
@@ -269,4 +278,11 @@
 </dd></dl>
 
+<p class="rubric">Footnotes</p>
+<table class="docutils footnote" frame="void" id="f1" rules="none">
+<colgroup><col class="label" /><col /></colgroup>
+<tbody valign="top">
+<tr><td class="label"><a class="fn-backref" href="#id1">[1]</a></td><td>fits.h (here named pyfits.h) is part of MARS and was written by T.Bretz, it was added to this repository for convienience</td></tr>
+</tbody>
+</table>
 </div>
 </div>
@@ -285,5 +301,5 @@
 <li><a class="reference internal" href="#environment-variables">2. Environment variables</a></li>
 <li><a class="reference internal" href="#check-out-the-repository">3. Check out the repository</a></li>
-<li><a class="reference internal" href="#create-pyfits-library">4. Create pyfits library</a></li>
+<li><a class="reference internal" href="#create-pyfits-h-so-library">4. Create pyfits_h.so library</a></li>
 <li><a class="reference internal" href="#run-examples">5. Run examples</a></li>
 </ul>
Index: fact/tools/pyscripts/doc/_build/html/index.html
===================================================================
--- fact/tools/pyscripts/doc/_build/html/index.html	(revision 13316)
+++ fact/tools/pyscripts/doc/_build/html/index.html	(revision 13324)
@@ -59,5 +59,5 @@
 <li class="toctree-l2"><a class="reference internal" href="getting_started.html#environment-variables">2. Environment variables</a></li>
 <li class="toctree-l2"><a class="reference internal" href="getting_started.html#check-out-the-repository">3. Check out the repository</a></li>
-<li class="toctree-l2"><a class="reference internal" href="getting_started.html#create-pyfits-library">4. Create pyfits library</a></li>
+<li class="toctree-l2"><a class="reference internal" href="getting_started.html#create-pyfits-h-so-library">4. Create pyfits_h.so library</a></li>
 <li class="toctree-l2"><a class="reference internal" href="getting_started.html#run-examples">5. Run examples</a></li>
 </ul>
Index: fact/tools/pyscripts/doc/_build/html/searchindex.js
===================================================================
--- fact/tools/pyscripts/doc/_build/html/searchindex.js	(revision 13316)
+++ fact/tools/pyscripts/doc/_build/html/searchindex.js	(revision 13324)
@@ -1,1 +1,1 @@
-Search.setIndex({objects:{"pyfact.fnames":{info:[5,0,1],make:[5,0,1]},"pyfact.RawData":{info:[5,0,1],baseline_read_values:[5,0,1],baseline_correct:[5,0,1],data_file:[5,1,1],npix:[5,1,1],next:[5,0,1],calib_file:[5,1,1],nroi:[5,1,1],nevents:[5,1,1],board_times:[5,1,1],start_cells:[5,1,1],next_event:[5,0,1],calibrate_drs_amplitude:[5,0,1],data:[5,1,1]},pyfact:{fnames:[5,2,1],RawData:[5,2,1]}},terms:{all:5,code:[1,0],bsl_sum:5,edu:5,follow:[1,2,5],primer:1,row:5,categori:5,depend:5,program:1,matlab:2,unzip:[3,5],string:[3,5],account:5,readout:5,strang:5,fad:5,bslfname:[],list:[1,3,4,5],"try":5,baslin:5,vector:[],my_scrip:4,dir:4,swdev_nf:5,telescop:5,phyton:[2,0],hplt_mean:5,append:[3,5],index:[0,5],disk:5,pyroot:5,cell:[],version:[1,0,5],"new":1,full:[],aclic:5,gener:1,root_v5:5,here:5,path:[3,5],sinc:5,interpret:5,search:[0,5],cern:5,typic:[],fourier:2,calibr:[3,5],appli:[],modul:[1,0,5,4,2],unig:5,filenam:[3,5],instal:2,unit:5,plot:2,feb:5,zip:[3,5],visit:[],upgrad:2,next:5,few:5,call:[0,4],checkout:5,calf:[],drscal:[3,5],"__iter__":5,particular:4,must:5,none:5,setup:5,work:1,dev:1,ecampl:5,can:4,learn:1,"0x9541844":[],vallu:[],dec:5,root:5,process:2,rpath:[3,5],share:5,indic:0,tag:[3,5],tabl:0,want:5,multipl:5,how:5,env:5,gate:[],simpl:5,luster:5,int16:[],max:[],pyfit:[2,0,5],befor:5,npy:5,date:5,data:[1,0,3,5],averag:[],baseline_read_valu:5,alloc:5,pyfact:[1,0,3,5,2],environ:[2,0,5],allow:2,help:5,soon:2,tunixsystem:5,sumaroundpeak:[],still:2,fir:[0,3],style:[1,0],fit:[2,5],window:[],pixel:5,readbaselin:[],scipi:2,thei:2,python:[1,0,5,4,2],calfnam:[],v_bsl:[],initi:5,software_hardwar:5,petter:1,introduct:[1,0],name:[3,5],slide:[],compris:1,tcshrc:5,nevent:5,our:[],event:5,out:[0,5],variabl:[0,5],miss:2,content:0,print:[3,5],calib_fil:5,correct:[],pyscript:5,pceth118:5,standard:2,dictionari:[3,5],org:[1,5],basi:2,maxpo:[],drupal:5,startcel:[],filter:[0,3],thing:1,length:5,lambda:5,oper:2,softwar:5,suffix:[3,5],arrai:5,misc:2,number:5,echo:4,stsci:5,instruct:5,open:5,convent:[1,0],script:4,"0xa818844":5,system:[2,0,4],least:5,"0xa872844":[],start_cel:5,too:5,statement:5,store:5,shell:5,tool:[1,5],specifi:[3,5],part:2,enclos:5,provid:[1,2,5],data_file_nam:5,project:5,rootsi:5,"function":[2,0,3,5],comput:2,ani:[1,4],raw:5,hava:[],have:5,close:1,need:1,lib:5,min:[],self:[],fact_runinfo:5,fname:[0,3,5],findpeak:[],datacent:5,juli:5,smoothdata:[],filtercfd:[],distribut:2,plenti:5,buffer:5,object:5,bsl:[3,5],most:1,jsp:5,automodul:[],histogram:5,"class":[1,0,3,5],windows:[],doc:[],later:1,fact:[1,0,3,5,2],radik:[3,5],acaldata:[],fine:1,find:5,absolut:5,ratio:[],just:1,should:[1,5],suppos:[1,2,4],analys:1,get:[0,5],run_db:5,return_dict:5,organ:[3,5],bsl_hist:5,patch:5,integr:[],contain:5,logbook:5,where:5,set:5,next_ev:5,result:[3,5],dfname:[],concern:5,data_fil:5,databas:5,"0xa13c844":[],between:5,"import":[0,4,5],attribut:[],web:[],numer:2,filnam:[],han:1,region:5,instanc:5,context:5,col:5,scratch_nf:[3,5],load:5,among:2,linux:5,astropython:1,guid:[1,0],creat:[0,3,4,5],numpi:2,trigger:5,valu:5,interest:5,basic:[1,5],presenc:2,sotwar:[],present:2,"case":1,look:5,packag:[2,5],npix:5,"0xb411844":[],defin:[3,5],board_tim:5,"00h":5,site:[],cluster:[1,2],inform:5,welcom:0,perform:5,make:[3,5],filterslidingaverag:[],member:[],cint:5,document:[1,0],complet:[3,5],http:[1,5],maxamp:[],php:5,studi:1,calib_file_nam:5,task:1,center:5,ld_library_path:5,thought:1,exampl:[1,0,4,5],command:[2,0,4,5],rawdata:[0,3,5],thi:[1,4,5],gzip:5,left:[],baseline_correct:5,execut:4,languag:1,my_script:4,langtangen:1,easi:2,add:[1,5],book:1,"0xa1d7844":[],bin:5,around:[],read:5,calibrate_drs_amplitud:5,like:2,specif:1,bashrc:5,signal:2,"0xa93e844":[],page:[1,0,5],yyyi:[3,5],www:[1,5],right:[],some:5,pipelin:[],yyyymmdd:[3,5],home:5,librari:[0,5],slice:5,pep:1,larg:5,elogbook:5,"0xa187844":[],run:[2,0,3,5],host:5,repositori:[0,5],from:[4,5],subtract:5,about:5,would:1,correctbaselin:[],plan:2,own:4,"0x9b7a844":[],pythonpath:5,within:4,your:[4,5],institut:5,user_action_calib:5,support:1,transform:2,"long":[1,4],avail:5,start:[0,5],interfac:5,includ:[2,5],fraction:[],analysi:[],fits_h:5,pwd:4,link:[0,5],ethz:5,line:4,mitig:5,"true":[3,4,5],info:[3,5],wise:1,possibl:5,"default":5,type:5,autoclass:[],access:[1,0,3,5,2],maximum:[],"0x9f4e844":[],problem:5,constant:[],cfddata:[],novemb:[],isdc:[1,2,5],file:[2,3,5],calibrate_drsamplitud:[],check:[0,5],fill:[],when:5,baseline_file_nam:5,other:2,branch:5,you:[1,4,5],baselin:5,factelog:5,docstr:[],substract:5,palma:5,peak:[],amplitud:5,matplotlib:2,svn:5,"0x94b8844":[],scientif:[1,2],directori:[3,5],time:5,nroi:5},objtypes:{"0":"py:method","1":"py:attribute","2":"py:class"},titles:["Welcome to pyfact&#8217;s documentation!","Introduction","phyton in FACT","Classes","Examples","Getting Started"],objnames:{"0":"Python method","1":"Python attribute","2":"Python class"},filenames:["index","introduction","python","classes","examples","getting_started"]})
+Search.setIndex({objects:{"pyfact.fnames":{info:[5,0,1],make:[5,0,1]},"pyfact.RawData":{info:[5,0,1],baseline_read_values:[5,0,1],baseline_correct:[5,0,1],data_file:[5,1,1],npix:[5,1,1],next:[5,0,1],calib_file:[5,1,1],nroi:[5,1,1],nevents:[5,1,1],board_times:[5,1,1],start_cells:[5,1,1],next_event:[5,0,1],calibrate_drs_amplitude:[5,0,1],data:[5,1,1]},pyfact:{fnames:[5,2,1],RawData:[5,2,1]}},terms:{all:5,code:[1,0],bsl_sum:5,my_dict:5,edu:5,follow:[1,2,5],primer:1,row:5,footnot:5,depend:5,program:1,matlab:2,unzip:[3,5],string:[3,5],account:5,readout:5,strang:5,fad:5,bslfname:[],heasarc:[],list:[1,3,4,5],"try":5,baslin:5,vector:[],my_scrip:4,dir:4,cfitsio:5,swdev_nf:5,telescop:5,phyton:[2,0],hplt_mean:5,append:[3,5],index:[0,5],disk:5,pyroot:5,cell:[],version:[1,0,5],"new":1,full:[],aclic:5,gener:1,root_v5:5,here:5,trunk:5,path:[3,5],sinc:5,interpret:5,search:[0,5],cern:[],typic:[],fourier:2,calibr:[3,5],appli:[],"0xa1d7844":[],unig:5,filenam:[3,5],instal:2,unit:5,plot:2,feb:[],zip:[3,5],visit:[],upgrad:2,next:5,few:5,call:[0,4],checkout:5,calf:[],drscal:[3,5],"__iter__":5,particular:4,must:5,none:5,setup:5,work:[1,5],dev:1,ecampl:5,can:[4,5],learn:1,"0x9541844":[],vallu:[],dec:5,root:5,process:2,rpath:[3,5],share:5,indic:0,tag:[3,5],tabl:0,want:5,"0xab028b4":5,multipl:5,how:5,env:5,gate:[],simpl:5,luster:[],bretz:5,mar:5,max:[],"0x9d0687c":[],pyfit:[2,5],befor:5,npy:5,date:5,data:[1,0,3,5],averag:[],baseline_read_valu:5,alloc:5,pyfact:[1,0,3,5,2],environ:[2,0,5],allow:2,help:5,soon:2,tunixsystem:5,sumaroundpeak:[],still:2,fir:[0,3],style:[1,0],fit:[2,5],window:[],fitsio:[],might:5,pixel:5,readbaselin:[],scipi:2,thei:2,python:[1,0,5,4,2],calfnam:[],v_bsl:[],initi:5,software_hardwar:5,petter:1,now:5,introduct:[1,0],name:[3,5],slide:[],compris:1,tcshrc:5,nevent:5,int16:[],our:[],event:5,out:[0,5],variabl:[0,5],open:5,categori:[],print:[3,5],got:5,gov:[],calib_fil:5,correct:[],pyscript:5,pceth118:[],standard:2,reason:5,dictionari:[3,5],org:[1,5],basi:2,maxpo:[],drupal:[],startcel:[],filter:[0,3],thing:1,length:5,lambda:5,oper:2,softwar:5,suffix:[3,5],arrai:5,misc:2,number:5,echo:4,stsci:5,instruct:5,done:5,miss:2,rootcint:5,convent:[1,0],script:4,"0xa818844":[],system:[2,0,4],least:5,"0xa872844":[],start_cel:5,too:5,statement:5,which:5,store:5,shell:5,tool:[1,5],specifi:[3,5],convieni:5,enclos:5,provid:[1,2,5],"0xae4487c":[],data_file_nam:5,project:5,rootsi:5,"function":[2,0,3,5],comput:2,ani:[1,4],raw:5,hava:[],have:5,close:1,need:1,lib:5,min:[],self:[],fact_runinfo:5,fname:[0,3,5],findpeak:[],datacent:5,juli:5,smoothdata:[],pipelin:[],distribut:2,plenti:5,buffer:5,object:5,bsl:[3,5],most:1,jsp:5,automodul:[],histogram:5,"class":[1,0,3,5],windows:[],doc:[],later:[1,5],part:[2,5],fact:[1,0,3,5,2],radik:[3,5],rubric:[],acaldata:[],fine:1,find:5,absolut:5,ratio:[],just:1,should:[1,5],suppos:[1,2,4],analys:1,get:[0,5],run_db:5,return_dict:5,"0x9ad887c":[],organ:[3,5],bsl_hist:5,patch:[],integr:[],contain:5,logbook:5,where:5,set:5,next_ev:5,"0x9cdd87c":[],result:[3,5],content:0,dfname:[],concern:5,data_fil:5,databas:5,written:5,"0xa13c844":[],between:5,"import":[0,4,5],attribut:[],web:[],numer:2,filnam:[],han:1,region:5,instanc:5,context:[],lusterma:5,col:5,scratch_nf:[3,5],load:5,among:2,linux:[],astropython:1,guid:[1,0],creat:[0,3,4,5],numpi:2,trigger:5,valu:5,interest:5,basic:[1,5],presenc:2,sotwar:[],present:2,"case":1,look:5,packag:2,npix:5,"0xb411844":[],whatenv:5,defin:[3,5],board_tim:5,"00h":[],site:[],cluster:[1,2],inform:5,welcom:0,perform:5,pyfits_h:[0,5],make:[3,5],filterslidingaverag:[],member:[],cint:5,document:[1,0],complet:[3,5],http:[1,5],maxamp:[],php:5,studi:1,calib_file_nam:5,task:1,center:5,ld_library_path:5,thought:1,exampl:[1,0,4,5],command:[2,0,4,5],rawdata:[0,3,5],thi:[1,4,5],gzip:5,left:[],baseline_correct:5,execut:4,languag:1,my_script:4,langtangen:1,easi:2,add:[1,5],book:1,modul:[1,0,5,4,2],bin:5,around:[],read:5,calibrate_drs_amplitud:5,"0xa6df87c":[],like:[2,5],specif:1,bashrc:5,signal:2,"0xa93e844":[],page:[1,0,5],yyyi:[3,5],www:[1,5],right:[],some:5,filtercfd:[],yyyymmdd:[3,5],home:[],librari:[0,5],slice:5,fpic:5,pep:1,larg:5,elogbook:5,gsfc:[],"0xa187844":[],home_nf:5,run:[2,0,3,5],host:5,repositori:[0,5],from:[4,5],subtract:5,about:5,would:1,correctbaselin:[],plan:2,own:4,"0x9b7a844":[],pythonpath:5,within:4,your:[4,5],"0x956d87c":[],institut:5,user_action_calib:5,support:1,transform:2,"long":[1,4],avail:5,start:[0,5],interfac:5,includ:[2,5],fraction:[],analysi:[],linuxx8664gcc:5,fits_h:5,pwd:4,link:[0,5],ethz:5,line:4,mitig:5,"true":[3,4,5],info:[3,5],wise:1,possibl:5,"default":[],type:5,autoclass:[],access:[1,0,3,5,2],maximum:[],"0x9f4e844":[],problem:5,constant:[],cfddata:[],novemb:[],isdc:[1,2,5],exist:5,file:[2,3,5],calibrate_drsamplitud:[],check:[0,5],fill:[],when:5,baseline_file_nam:5,other:2,branch:[],you:[1,4,5],baselin:5,factelog:5,docstr:[],substract:5,palma:5,peak:[],amplitud:5,cn02:5,matplotlib:2,svn:5,"0xa1368b4":[],"0x94b8844":[],scientif:[1,2],directori:[3,5],izstream:5,nasa:[],time:5,nroi:5},objtypes:{"0":"py:method","1":"py:attribute","2":"py:class"},titles:["Welcome to pyfact&#8217;s documentation!","Introduction","phyton in FACT","Classes","Examples","Getting Started"],objnames:{"0":"Python method","1":"Python attribute","2":"Python class"},filenames:["index","introduction","python","classes","examples","getting_started"]})