Index: /fact/tools/pyscripts/pyfact/PulseTemplate_PointSet_1.csv
===================================================================
--- /fact/tools/pyscripts/pyfact/PulseTemplate_PointSet_1.csv	(revision 13418)
+++ /fact/tools/pyscripts/pyfact/PulseTemplate_PointSet_1.csv	(revision 13418)
@@ -0,0 +1,310 @@
+### point-set of a single photon pulse template
+### template determined with pulse overlay at: Maximum
+### Slice's Amplitude determined by calculating the 
+### value of maximum propability of slice -> Amplitude1 
+### mean of slice -> Amplitude2 
+### median of slice -> Amplitude3 
+### for each slice
+### Pixel number (CHid): 1
+
+time [slices],Amplitude1 [mV],Amplitude2 [mV],Amplitude3 [mV]
+1,-0.25,-0.11869,-0.25
+2,-0.75,-0.614257,-0.75
+3,-0.75,-0.90797,-0.75
+4,-0.75,-0.520157,-0.75
+5,-0.25,-0.520451,-0.75
+6,-0.25,-0.393927,-0.75
+7,0.25,-0.562188,-0.75
+8,-0.25,-0.575069,-0.75
+9,-0.75,-0.824779,-0.75
+10,-1.25,-0.661299,-0.75
+11,-0.75,-0.156977,-0.25
+12,-0.25,-0.652045,-0.75
+13,-0.25,-0.932953,-0.75
+14,-0.75,-0.523746,-0.75
+15,-0.75,-0.592218,-0.75
+16,-0.75,-0.412599,-0.25
+17,-0.25,-0.641791,-0.75
+18,-1.25,-0.718553,-0.75
+19,-0.75,-0.996845,-1.25
+20,-1.25,-0.800574,-0.75
+21,-0.25,-0.301057,-0.25
+22,-0.75,-0.797385,-0.75
+23,-0.75,-0.964286,-0.75
+24,-0.25,-0.608974,-0.75
+25,-0.25,-0.595171,-0.75
+26,-0.75,-0.448075,-0.75
+27,-0.25,-0.646298,-0.75
+28,-0.25,-0.681624,-0.75
+29,-1.25,-0.883938,-0.75
+30,-0.25,-0.66206,-0.75
+31,-0.75,-0.315809,-0.25
+32,-0.75,-0.771351,-0.75
+33,-0.25,-1.12288,-1.25
+34,0.25,-0.75098,-0.75
+35,-0.75,-0.723723,-0.75
+36,-0.75,-0.582203,-0.75
+37,-0.75,-0.780266,-0.75
+38,-0.75,-0.779947,-0.75
+39,-1.25,-1.00168,-0.75
+40,-0.75,-0.883444,-0.75
+41,-0.75,-0.412577,-0.25
+42,-0.75,-0.858357,-0.75
+43,-0.75,-1.10541,-1.25
+44,-0.75,-0.728291,-0.75
+45,-0.25,-0.676089,-0.75
+46,-1.25,-0.559677,-0.75
+47,-0.75,-0.73036,-0.75
+48,-0.25,-0.680727,-0.75
+49,-0.25,-0.95023,-0.75
+50,-0.25,-0.706076,-0.75
+51,-0.25,-0.223933,-0.25
+52,-0.75,-0.687163,-0.75
+53,-0.75,-0.89527,-0.75
+54,-0.75,-0.435193,-0.75
+55,-0.75,-0.325664,-0.25
+56,-0.25,0.0585714,-0.25
+57,-0.25,0.251097,0.25
+58,0.75,0.860485,0.75
+59,1.25,1.4176,1.25
+60,2.75,2.68613,2.75
+61,4.75,4.48978,4.25
+62,4.75,5.36651,5.25
+63,7.25,6.22077,6.25
+64,8.25,8.37425,8.25
+65,9.75,9.23537,9.25
+66,10.25,10.1667,10.25
+67,10.25,10.4437,10.75
+68,10.75,10.6168,10.75
+69,10.75,10.4488,10.75
+70,10.75,10.33,10.25
+71,11.25,11.6247,11.75
+72,10.75,9.93358,10.25
+73,10.25,9.50989,9.75
+74,10.25,9.60643,9.75
+75,9.75,9.33398,9.25
+76,8.75,9.13602,9.25
+77,8.25,8.52079,8.75
+78,8.25,8.36245,8.25
+79,7.75,7.25328,7.25
+80,7.25,7.24122,7.25
+81,7.75,7.43124,7.75
+82,7.25,6.79729,6.75
+83,6.25,6.27161,6.25
+84,6.75,6.58422,6.75
+85,6.75,6.46728,6.75
+86,7.25,6.46126,6.75
+87,7.25,6.0799,6.25
+88,6.25,5.97899,6.25
+89,5.75,5.53555,5.75
+90,5.75,5.52118,5.75
+91,6.25,5.9332,5.75
+92,5.25,5.28376,5.25
+93,4.25,4.8121,4.75
+94,4.75,5.18635,5.25
+95,4.75,4.96788,4.75
+96,5.75,5.02618,4.75
+97,4.75,4.67419,4.75
+98,4.75,4.52832,4.25
+99,4.75,4.14284,4.25
+100,4.25,4.13711,4.25
+101,4.25,4.58617,4.25
+102,3.75,3.9689,3.75
+103,3.75,3.52381,3.75
+104,3.25,3.89272,3.75
+105,3.75,3.84564,3.75
+106,4.25,3.90984,3.75
+107,3.75,3.55943,3.25
+108,2.75,3.49682,3.25
+109,3.25,3.07489,2.75
+110,2.25,3.22581,2.75
+111,3.25,3.68307,3.25
+112,2.75,3.13507,2.75
+113,2.25,2.67782,2.25
+114,2.75,3.10234,2.75
+115,2.75,3.02887,2.75
+116,2.75,3.09982,2.75
+117,1.75,2.84035,2.25
+118,1.75,2.77087,2.25
+119,2.75,2.4934,2.25
+120,2.75,2.45545,2.25
+121,2.25,2.95518,2.25
+122,2.25,2.38491,2.25
+123,2.25,2.01716,1.75
+124,2.25,2.41808,2.25
+125,2.25,2.40682,2.25
+126,1.75,2.5132,2.25
+127,2.25,2.13538,1.75
+128,1.75,2.18022,1.75
+129,1.75,1.74621,1.25
+130,1.25,1.85568,1.25
+131,1.75,2.36963,1.75
+132,1.75,1.87056,1.25
+133,0.75,1.52308,1.25
+134,1.25,1.94906,1.25
+135,1.75,1.9584,1.25
+136,1.75,2.02487,1.25
+137,1.25,1.79127,1.25
+138,0.75,1.8096,1.25
+139,0.25,1.41439,0.75
+140,0.75,1.50687,1.25
+141,0.75,2.08621,1.25
+142,1.25,1.44375,0.75
+143,0.25,1.21489,0.75
+144,0.25,1.48104,0.75
+145,0.25,1.53072,1.25
+146,0.25,1.64049,1.25
+147,0.25,1.35533,0.75
+148,0.25,1.36055,0.75
+149,0.75,1.00374,0.75
+150,0.75,1.19832,0.75
+151,0.75,1.66873,1.25
+152,0.75,1.18693,0.75
+153,0.75,0.898871,0.75
+154,0.25,1.19312,0.75
+155,-0.25,1.16687,0.75
+156,0.25,1.3254,0.75
+157,1.25,1.05954,0.75
+158,0.25,1.03446,0.25
+159,0.25,0.765843,0.25
+160,-0.25,0.938332,0.25
+161,0.75,1.38726,0.75
+162,-0.25,0.899968,0.25
+163,0.25,0.619845,0.25
+164,0.75,0.992561,0.25
+165,0.25,1.03729,0.25
+166,0.25,1.21549,0.25
+167,0.25,0.890984,0.25
+168,0.25,0.890212,0.25
+169,-0.25,0.622667,0.25
+170,0.25,0.742282,0.25
+171,0.25,1.21799,0.75
+172,0.25,0.716079,0.25
+173,-0.25,0.423958,-0.25
+174,-0.25,0.764746,0.25
+175,0.25,0.747937,0.25
+176,-0.25,0.905579,0.25
+177,-0.25,0.624126,0.25
+178,-0.75,0.710867,0.25
+179,-0.25,0.409559,-0.25
+180,-0.75,0.572731,0.25
+181,0.25,1.05581,0.25
+182,-0.75,0.475127,0.25
+183,-0.25,0.301028,-0.25
+184,-0.25,0.579063,0.25
+185,0.25,0.565613,0.25
+186,-0.25,0.750373,0.25
+187,0.25,0.490559,0.25
+188,-0.25,0.492413,-0.25
+189,-0.25,0.0792308,-0.25
+190,0.25,0.311335,-0.25
+191,-0.25,0.776827,0.25
+192,-0.25,0.282651,-0.25
+193,0.75,0.158074,-0.25
+194,0.25,0.460987,-0.25
+195,0.25,0.509824,0.25
+196,-0.25,0.594507,-0.25
+197,0.25,0.485078,0.25
+198,-0.75,0.437142,-0.25
+199,-0.25,0.165833,-0.25
+200,-0.25,0.272538,-0.25
+201,0.25,0.745405,0.25
+202,-0.75,0.299747,-0.25
+203,-1.25,0.142888,-0.25
+204,-0.75,0.464043,-0.25
+205,-0.75,0.472079,-0.25
+206,-0.75,0.618421,0.25
+207,-0.75,0.464844,0.25
+208,-0.75,0.353299,-0.25
+209,-0.75,0.102423,-0.25
+210,-0.25,0.207257,-0.25
+211,-0.25,0.700893,0.25
+212,-0.25,0.206109,-0.25
+213,-0.75,-0.0243119,-0.25
+214,-0.75,0.316237,-0.25
+215,-0.25,0.292326,-0.25
+216,-0.75,0.36784,-0.25
+217,-0.75,0.225379,-0.25
+218,-0.25,0.196395,-0.25
+219,-0.25,-0.00289575,-0.25
+220,-0.75,0.215601,-0.25
+221,0.25,0.671769,0.25
+222,-0.75,0.222468,-0.25
+223,-0.25,0.00520317,-0.25
+224,0.25,0.374502,-0.25
+225,-0.25,0.321214,-0.25
+226,-0.25,0.507852,-0.25
+227,-0.75,0.359568,-0.25
+228,-0.75,0.388287,-0.25
+229,-0.75,0.0378788,-0.75
+230,0.25,0.345541,-0.25
+231,0.25,0.779162,0.25
+232,-0.75,0.154891,-0.25
+233,-0.75,0.0426293,-0.75
+234,-0.75,0.294653,-0.25
+235,-0.75,0.343333,-0.25
+236,-0.75,0.551578,-0.25
+237,-0.25,0.313429,-0.25
+238,-0.25,0.341065,-0.25
+239,0.25,-0.0413247,-0.25
+240,-0.25,0.173439,-0.25
+241,-0.25,0.538076,-0.25
+242,-0.25,0.105072,-0.25
+243,-0.25,-0.0910758,-0.75
+244,-0.75,0.291667,-0.25
+245,0.25,0.238272,-0.25
+246,-0.25,0.300248,-0.25
+247,-0.75,0.187975,-0.25
+248,-1.25,0.0869565,-0.25
+249,-0.25,-0.154575,-0.75
+250,-1.75,0.0183727,-0.25
+251,-0.25,0.512187,-0.25
+252,-0.25,0.15721,-0.25
+253,-0.25,-0.247954,-0.75
+254,-1.25,0.288934,-0.25
+255,-0.75,0.196575,-0.25
+256,-0.25,0.337535,-0.25
+257,-0.75,0.0258865,-0.25
+258,-1.25,0.0888017,-0.25
+259,-0.75,-0.27193,-0.75
+260,-0.75,-0.00953079,-0.25
+261,-0.75,0.502555,-0.25
+262,-0.75,0.0966667,-0.25
+263,-0.25,-0.0227964,-0.25
+264,0.25,0.279367,-0.25
+265,0.25,0.311927,-0.25
+266,-0.25,0.312888,-0.25
+267,0.25,0.245981,-0.25
+268,-0.25,0.149518,-0.25
+269,-0.25,-0.213355,-0.75
+270,-0.25,-0.0373754,-0.5
+271,-0.75,0.299085,-0.25
+272,-1.25,-0.135077,-0.75
+273,-0.75,-0.325,-0.75
+274,-0.75,0.108131,-0.25
+275,-1.25,0.0021815,-0.75
+276,-0.75,0.147869,-0.25
+277,-0.75,0.0628391,-0.25
+278,-1.25,-0.195572,-0.75
+279,-0.75,-0.319811,-0.75
+280,-0.75,-0.24031,-0.75
+281,-0.25,0.340467,-0.25
+282,0.25,-0.232143,-0.75
+283,-0.75,-0.384615,-0.75
+284,-0.75,0.0901222,-0.25
+285,-0.75,0.0326087,-0.25
+286,-0.75,0.0889474,-0.25
+287,-0.25,-0.137473,-0.75
+288,-0.75,-0.118363,-0.75
+289,-0.25,-0.345455,-0.75
+290,-0.25,-0.210227,-0.75
+291,-1.25,0.221198,-0.25
+292,0.25,-0.177896,-0.75
+293,0.25,-0.410147,-0.75
+294,-1.25,-0.00615764,-0.25
+295,0.25,0.0252525,-0.25
+296,-1.25,0.153101,-0.25
+297,-1.25,0.0431034,-0.25
+298,-1.25,-0.150815,-0.75
+299,-1.75,-0.308172,-0.75
+300,-1.25,-0.263889,-0.75